module Memiescape.App where

import Data.Maybe (Maybe(..))
import Data.Tuple.Nested ((/\))
import Prelude (($), bind, pure)
import Reactix as R
import Reactix.DOM.HTML as H

import Memiescape.Loader (loader)
import Memiescape.Viewer (viewer)

thisModule :: String
thisModule = "Memiescape.App"

app :: {} -> R.Element
app props = R.createElement appCpt props []

appCpt :: R.Component ()
appCpt = R.hooksComponentWithModule thisModule "app" cpt
  where
    cpt {} _ = do
      file <- R.useState' Nothing

      pure $ H.div {} [
          H.div {} [ H.text "Hello world" ]
        , H.div {} [
            loader { file }
          ]
        , H.div {} [
             v file
          ]
        ]
      where
        v (Just f /\  _) = viewer { file: f }
        v _             = H.div {} []
